(function (a) {
    a(document).ready(function () {
        var e = new WOW({ boxClass: 'wow', animateClass: 'animated', offset: 0, mobile: true, live: true });
        e.init();
        a('[data-toggle="tooltip"]').tooltip();
        function d(g) {
            var f = 'webkitAnimationEnd animationend';
            g.each(function () {
                var i = a(this),
                    h = i.data('animation');
                i.addClass(h).one(f, function () {
                    i.removeClass(h);
                });
            });
        }
        var c = a('.animate_text'),
            b = c.find('.item:first').find("[data-animation ^= 'animated']");
        c.carousel();
        d(b);
        c.on('slide.bs.carousel', function (g) {
            var f = a(g.relatedTarget).find("[data-animation ^= 'animated']");
            d(f);
        });
        a('.player').mb_YTPlayer();
        a('#portfolio-grid,.blog-masonry').imagesLoaded(function () {
            a('.mix-item-menu').on('click', 'button', function () {
                var g = a(this).attr('data-filter');
                f.isotope({ filter: g });
            });
            a('.mix-item-menu button').on('click', function (g) {
                a(this).siblings('.active').removeClass('active');
                a(this).addClass('active');
                g.preventDefault();
            });
            var f = a('#portfolio-grid').isotope({ itemSelector: '.pf-item', percentPosition: true, masonry: { columnWidth: '.pf-item' } });
            a('.blog-masonry').isotope({ itemSelector: '.blog-item', percentPosition: true, masonry: { columnWidth: '.blog-item' } });
        });
        a('.timer').countTo();
        a('.fun-fact').appear(
            function () {
                a('.timer').countTo();
            },
            { accY: -100 }
        );
        a('.popup-link').magnificPopup({ type: 'image' });
        a('.popup-gallery').magnificPopup({ type: 'image', gallery: { enabled: true } });
        a('.popup-youtube, .popup-vimeo, .popup-gmaps').magnificPopup({ type: 'iframe', mainClass: 'mfp-fade', removalDelay: 160, preloader: false, fixedContentPos: false });
        a('.magnific-mix-gallery').each(function () {
            var f = a(this);
            var g = f.find('.item');
            var h = [];
            g.each(function () {
                var i = a(this);
                var k = 'image';
                if (i.hasClass('magnific-iframe')) {
                    k = 'iframe';
                }
                var j = { src: i.attr('href'), type: k };
                j.title = i.data('title');
                h.push(j);
            });
            g.magnificPopup({
                mainClass: 'mfp-fade',
                items: h,
                gallery: { enabled: true, tPrev: a(this).data('prev-text'), tNext: a(this).data('next-text') },
                type: 'image',
                callbacks: {
                    beforeOpen: function () {
                        var i = g.index(this.st.el);
                        if (-1 !== i) {
                            this.goTo(i);
                        }
                    }
                }
            });
        });
        a('.features-carousel').owlCarousel({ loop: false, nav: false, margin: 30, dots: true, autoplay: false, items: 1, navText: ["<i class='fa fa-angle-left'></i>", "<i class='fa fa-angle-right'></i>"] });
        a('.testimonial-carousel').owlCarousel({ loop: false, margin: 30, nav: false, navText: ["<i class='ti-angle-left'></i>", "<i class='ti-angle-right'></i>"], dots: false, autoplay: true, responsive: { 0: { items: 1 }, 1000: { items: 2 } } });
        a('.partner-carousel').owlCarousel({ loop: false, margin: 50, nav: false, navText: ["<i class='ti-angle-left'></i>", "<i class='ti-angle-right'></i>"], dots: false, autoplay: true, responsive: { 0: { items: 2 }, 600: { items: 3, margin: 50 }, 1000: { items: 5, margin: 80 } } });
        a('.clients-carousel').owlCarousel({ loop: false, margin: 30, nav: false, navText: ["<i class='ti-angle-left'></i>", "<i class='ti-angle-right'></i>"], dots: false, autoplay: true, responsive: { 0: { items: 2 }, 600: { items: 3, margin: 50 }, 1000: { items: 4, margin: 80 } } });
        a('.overview-carousel').owlCarousel({ loop: true, nav: false, margin: 30, dots: true, autoplay: false, items: 1, navText: ["<i class='fa fa-angle-left'></i>", "<i class='fa fa-angle-right'></i>"], responsive: { 1200: { stagePadding: 300 } } });
        a('.contact-form').each(function () {
            var f = a(this);
            f.submit(function () {
                var g = a(this).attr('action');
                a('#message').slideUp(750, function () {
                    a('#message').hide();
                    a('#submit').after('<img src="assets/img/ajax-loader.gif" class="loader" />').attr('disabled', 'disabled');
                    a.post(g, { name: a('#name').val(), email: a('#email').val(), phone: a('#phone').val(), comments: a('#comments').val() }, function (h) {
                        document.getElementById('message').innerHTML = h;
                        a('#message').slideDown('slow');
                        a('.contact-form img.loader').fadeOut('slow', function () {
                            a(this).remove();
                        });
                        a('#submit').removeAttr('disabled');
                    });
                });
                return false;
            });
        });
    });
    a(window).on('load', function () {
        a('.se-pre-con').fadeOut('slow');
    });
})(jQuery);

function Zoom(obj) {
    if (!obj) {
        return;
    }
    let imgSrc = $(obj).attr('src');
    let i = layui.layer.open({
        type: 1,
        title: false,
        closeBtn: 0,
        area: ['100%', '100%'],
        skin: 'layer-fullscreen',
        content: `<img src='${imgSrc}' />`
    });
    let layerDom = $('div[id="layui-layer' + i + '"]').eq(0);
    let content = layerDom.find('div.layui-layer-content').eq(0);
    let viewerCanvas = null;
    let viewer = null;
    let loadIng = layer.alert('加载图片中...', { icon: 16, shade: false, closeBtn: 0, anim: -1, btn: false });
    content.on('click', function (e) {
        if (e.target.tagName == 'IMG') {
            return;
        }
        if (viewerCanvas) {
            viewerCanvas.unbind('click');
        }
        if (viewer) {
            viewer.destroy();
        }
        layer.close(i);
        layer.close(loadIng);
    });
    let img = content.find('img').eq(0);
    viewer = new Viewer(img[0], {
        inline: true,
        viewed() {
            this.viewer.zoomTo(1);
            layer.close(loadIng);
            let full = content.find('div[class$="viewer-fullscreen"]').eq(0);
            // full.click();
            full.bind('click', function () {
                full.unbind('click');
                viewer.destroy();
                layer.close(i);
                layer.close(loadIng);
            });
            viewerCanvas.bind('click', function (e) {
                if (e.target.tagName == 'IMG') {
                    return;
                }
                viewerCanvas.unbind('click');
                viewer.destroy();
                layer.close(i);
                layer.close(loadIng);
            });
        }
    });
    viewerCanvas = content.find('div[class$="viewer-canvas"]').eq(0);
    img.hide();
}

var _client_ = { x: 0, y: 0 };

function getClient(event) {
    let x, y;
    if (event.changedTouches) {
        x = event.changedTouches[0].clientX;
        y = event.changedTouches[0].clientY;
    } else {
        x = event.clientX;
        y = event.clientY;
    }
    return { x, y };
}

function touch(that, state, event) {
    if (state === 0) {
        let { x, y } = getClient(event);
        _client_.x = x;
        _client_.y = y;
    } else if (state === 1) {
        let deviation = 30;
        let { x, y } = getClient(event);
        if (Math.abs(_client_.x - x) > deviation || Math.abs(_client_.y - y) > deviation) {
            return;
        }
        Zoom(that);
    }
}
